from rocolib.api.components.Component import newComponent
from rocolib.api.Function import Function

c = newComponent("Angle")

c.addParameter("h", 20, paramType="length")
c.addParameter("angle", 90, paramType="angle")

c.addSubcomponent("base", "Rectangle", inherit=True, prefix=None)
c.addSubcomponent("edge", "Rectangle")
c.addConstraint(("edge", "w"), "h")

c.join(("base", "b"), ("edge", "t"), angle=Function("angle"))

c.toLibrary(True)
