from rocolib.api.components.Component import newComponent
from rocolib.api.Function import Function


c = newComponent("MountedBrains")

c.addSubcomponent("beam", "SimpleRectBeam", inherit=True, prefix=None)
c.addSubcomponent("brain", "Brains", inherit="brain", prefix=None)
c.delParameter("width")
c.delParameter("depth")

c.addParameter("width", 50, paramType="length")
c.addParameter("depth", 20, paramType="length")
c.addParameter("offset", (0,0), valueType="list")

c.addConstraint(("beam", "width"), "depth")
c.addConstraint(("beam", "depth"), "width")

c.addConstraint(("beam", "width#minValue"), "brain", 'x.get("height")')
c.addConstraint(("beam", "depth#minValue"), "brain", 'x.get("width")')
c.addConstraint(("beam", "length#minValue"), "brain", 'x.get("length")')

c.addConnection(("beam", "face1"),
                   ("brain", "decoration"),
                   mode="hole", offset=Function(params=("offset")))

c.inheritAllInterfaces("beam", prefix=None)

c.toLibrary(True)
