from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RegularNGon2 as NGonRadius, RegularNGon as NGonEdge


class RegularNGon(FoldedComponent):
  def define(self):
    self.addParameter("n", 5, valueType="int", minValue=3)
    self.addParameter("l", 25, paramType="length")
    self.addParameter("ltype", "radius", values=("radius", "edge"))

    for i in range(10):
      self.addEdgeInterface(f"e{i}", f"e{i}", "l")
    self.addFaceInterface("face", "r")

  def assemble(self):
    if self.p.ltype == "radius":
      Shape = NGonRadius
    else:
      Shape = NGonEdge
    self.addFace(Shape("r", self.p.n, self.p.l))

    for i in range(self.p.n):
        try: 
            self.setEdgeInterface("e%d" % i, "e%d" % i, "l")
        except KeyError:
            self.addEdgeInterface("e%d"%i, "e%d" % i, "l")

if __name__ == "__main__":
    RegularNGon.test()
