from rocolib.api.components.Component import Component
from rocolib.api.ports.EdgePort import EdgePort
from rocolib.api.Function import Function


class ServoMount(Component):
  def define(self): pass

  def modifyParameters(self):
    if self.p.offset:
        return

    ml = self.p.servo.get("motorlength")
    sl = self.p.servo.get("shoulderlength")
    ho = self.p.servo.get("hornoffset")

    dy = self.p.length/2. - ml/2. - sl
    if self.p.center:
      dy = min(dy, ml/2. - ho)
    dy -= self.p.shift
    if self.p.flip:
      dy = -dy

    self.p.offset = (0, dy)

if __name__ == "__main__":
  ServoMount.test()

